#ifndef _GLOBALS_H_
#define _GLOBALS_H_

/*
 * $Id: globals.h,v 1.9.4.1 1998/04/26 04:12:18 marc Exp $
 * 
 * Copyright (c) 1996, Marc Horowitz.  All rights reserved.
 * See the LICENSE file in the release for redistribution information.
 */

/* if you create a modified version of the key server, instead of
   incrementing this number, append a descriptive string, like
   "42.17.0-joe", or "42.17.0-magicfeature" */

#define PKS_VERSION "0.9.3-db2test"

#ifdef DEBUG
extern int debug;

#define dabort() if (debug) abort()
#define fail() {dabort(); else return(0); }
#else
#define dabort()
#define fail() return(0)
#endif

extern int log_terminal;

void log_debug(char *fct, char *msg);
void log_info(char *fct, char *msg);
void log_error(char *fct, char *msg);
void log_fatal(char *fct, char *msg);

#define EXIT_SIGNAL	1
#define EXIT_SHUTDOWN	2

#endif
