#ifndef _KD_INTERNAL_H_
#define _KD_INTERNAL_H_

/*
 * $Id: kd_internal.h,v 1.4 1996/12/11 19:16:35 marc Exp $
 * 
 * Copyright (c) 1996, Marc Horowitz.  All rights reserved.
 * See the LICENSE file in the release for redistribution information.
 */

#include <db.h>
#include "llist.h"

#define KEYDB_KEYID_BYTES 4

typedef struct _error {
   int fatal;
   char *str;
   char buf[1024];
} error;

extern DB *keydb, *worddb, *timedb;

int kd_add_userid_to_wordlist(llist *wl,
			      unsigned char *userid, long userid_len);
int kd_keys_elem_marshall(void *e, void *c);
int kd_db_store_keyblock(llist *keys, error *err);

void kd_log_start(char *fct, unsigned char *userid, long len, int flags);
void kd_log_finish(char *fct, int success);

/* from kd_add.c */

int kd_sigs_elem_merge(llist *lout, void *e1, void *e2, void *c);
int kd_userids_elem_merge(llist *lout, void *e1, void *e2, void *c);
int kd_keys_elem_merge(llist *lout, void *e1, void *e2, void *c);

#endif
