#ifndef _KD_SEARCH_H_
#define _KD_SEARCH_H_

/*
 * $Id: kd_search.h,v 1.6 1996/12/11 19:16:39 marc Exp $
 * 
 * Copyright (c) 1996, Marc Horowitz.  All rights reserved.
 * See the LICENSE file in the release for redistribution information.
 */

#include "llist.h"
#include "kd_internal.h"
#include "kd_types.h"

typedef int (*search_llist_filter)(void *e, llist *new_list,
				   void *c, error *err);

typedef struct _ow_state {
   unsigned char *userid;
   long userid_len;
   void *c;
   search_llist_filter filter;
   int return_disabled;
   llist_iter append;
   error *err;
} ow_state;

int kd_keyblock_iterate(unsigned char *block, long blocklen,
			llist_iter iter, void *c, error *err);
int kd_get_keys_by_keyid(unsigned char *keyid, llist *keys, error *err);
void kd_make_worddb_entry(keys_elem *ke, unsigned char entry[]);
int kd_output_wde(void *e, void *c);
int kd_search_1(unsigned char *userid, long len, int flags,
		llist_iter func, search_llist_filter filt,
		void *c, error *err);

#endif
