const char rcsid_logging_c[] = "$Id: logging.c,v 1.3 1996/12/11 19:16:53 marc Exp $";

/* 
 * Copyright (c) 1996, Marc Horowitz.  All rights reserved.
 * See the LICENSE file in the release for redistribution information.
 */


#include <syslog.h>
#include <stdio.h>

#include "globals.h"
#include "database.h"

#ifndef DEBUG
#define debug 0
#endif

int log_terminal;

void log_debug(char *fct, char *msg)
{
   if (debug || log_terminal)
      fprintf(stderr, "%s: %s\n", fct, msg);
   else
      syslog(LOG_DEBUG, "pksd: %s: %s", fct, msg);
}

void log_info(char *fct, char *msg)
{
   if (debug || log_terminal)
      fprintf(stderr, "%s: %s\n", fct, msg);
   else
      syslog(LOG_INFO, "pksd: %s: %s", fct, msg);
}

void log_error(char *fct, char *msg)
{
   if (debug || log_terminal)
      fprintf(stderr, "%s: %s\n", fct, msg);
   else
      syslog(LOG_ERR, "pksd: %s: %s", fct, msg);
}

void log_fatal(char *fct, char *msg)
{
   /* try to keep the database intact */
   kd_close();

   if (debug || log_terminal)
      fprintf(stderr, "FATAL ERROR in %s: %s\n", fct, msg);
   else
      syslog(LOG_CRIT, "pksd: %s: %s", fct, msg);

   exit(1);
}

